//*****************************************************************************
// Copyright 2019 Intel Corporation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//*****************************************************************************

#pragma once

#include <memory>
#include <vector>

#include "ngraph/op/op.hpp"

namespace ngraph {
namespace op {

class CropIE : public Op {
public:
    CropIE(const std::shared_ptr<Node>& data1,
           std::vector<int64_t> axes,
           std::vector<int64_t> dim,
           std::vector<int64_t> offset);

    void validate_and_infer_types() override;

    std::shared_ptr<Node> copy_with_new_args(const NodeVector& new_args) const override;

    std::vector<int64_t> axes, dim, offset;
};

}  // namespace op
}  // namespace ngraph
